<html>
<head>
<title>OGRE: Ogre::MemoryDataStream Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1MemoryDataStream.html">MemoryDataStream</a></div>
<h1>Ogre::MemoryDataStream Class Reference</h1><!-- doxytag: class="Ogre::MemoryDataStream" --><!-- doxytag: inherits="Ogre::DataStream" -->Common subclass of <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading of data.">DataStream</a> for handling data from chunks of memory.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::MemoryDataStream:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1MemoryDataStream-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#2196ee12b153b73e168f3ae3ba3a431e">MemoryDataStream</a> (void *pMem, size_t size, bool freeOnClose=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Wrap an existing memory chunk in a stream.  <a href="#2196ee12b153b73e168f3ae3ba3a431e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#629c4366d9ecb8a06286b7380dd53d26">MemoryDataStream</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, void *pMem, size_t size, bool freeOnClose=false)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Wrap an existing memory chunk in a named stream.  <a href="#629c4366d9ecb8a06286b7380dd53d26"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#24bf41fe1508cbf5d98280c6208a0e11">MemoryDataStream</a> (<a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;sourceStream, bool freeOnClose=true)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a stream which pre-buffers the contents of another stream.  <a href="#24bf41fe1508cbf5d98280c6208a0e11"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#6895d655ea18c8a2555089413b6fda58">MemoryDataStream</a> (<a class="el" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> &amp;sourceStream, bool freeOnClose=true)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a stream which pre-buffers the contents of another stream.  <a href="#6895d655ea18c8a2555089413b6fda58"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#8a0f76143497a2ae9ad691ed1555e4db">MemoryDataStream</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;sourceStream, bool freeOnClose=true)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a named stream which pre-buffers the contents of another stream.  <a href="#8a0f76143497a2ae9ad691ed1555e4db"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#93c7bb53e6b5a70df93a07b6b8669b2b">MemoryDataStream</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, const <a class="el" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> &amp;sourceStream, bool freeOnClose=true)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a named stream which pre-buffers the contents of another stream.  <a href="#93c7bb53e6b5a70df93a07b6b8669b2b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#d19e7001cc8f2568c15a8beaf938ea14">MemoryDataStream</a> (size_t size, bool freeOnClose=true)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a stream with a brand new empty memory chunk.  <a href="#d19e7001cc8f2568c15a8beaf938ea14"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#beef8ef4c1c13f8b3b91d13e9fd4269e">MemoryDataStream</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, size_t size, bool freeOnClose=true)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a named stream with a brand new empty memory chunk.  <a href="#beef8ef4c1c13f8b3b91d13e9fd4269e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#fffeeea1e906ef13aac0fdde018d3194">~MemoryDataStream</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#9d866cd1bbe58bbc59fdbc1dba024b9f">getPtr</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a pointer to the start of the memory block this stream holds.  <a href="#9d866cd1bbe58bbc59fdbc1dba024b9f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#c753e2375fcdf5e137210339350b5f21">getCurrentPtr</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a pointer to the current position in the memory block this stream holds.  <a href="#c753e2375fcdf5e137210339350b5f21"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#b3ee46ce477d58f8945340a4e2117820">read</a> (void *buf, size_t count)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Read the requisite number of bytes from the stream, stopping at the end of the file. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>buf</em>&nbsp;</td><td>Reference to a buffer pointer </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>count</em>&nbsp;</td><td>Number of bytes to read </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The number of bytes read </dd></dl>
  <a href="#b3ee46ce477d58f8945340a4e2117820"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#398aa1ba9f58276dc868d2c3968953c4">readLine</a> (char *buf, size_t maxCount, const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;delim=&quot;\n&quot;)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a single line from the stream. <p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>If you used this function, you <b>must</b> open the stream in <b>binary mode</b>, otherwise, it'll produce unexpected results. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>buf</em>&nbsp;</td><td>Reference to a buffer pointer </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>maxCount</em>&nbsp;</td><td>The maximum length of data to be read, excluding the terminating character </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>delim</em>&nbsp;</td><td>The delimiter to stop at </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The number of bytes read, excluding the terminating character </dd></dl>
  <a href="#398aa1ba9f58276dc868d2c3968953c4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#581ccd32944288808f7602b29a0218e9">skipLine</a> (const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;delim=&quot;\n&quot;)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Skip a single line from the stream. <p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>If you used this function, you <b>must</b> open the stream in <b>binary mode</b>, otherwise, it'll produce unexpected results. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>delim</em>&nbsp;</td><td>The delimiter(s) to stop at </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The number of bytes skipped </dd></dl>
  <a href="#581ccd32944288808f7602b29a0218e9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#bc0369bcd83740cf03cb27a11665486f">skip</a> (long count)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Skip a defined number of bytes. <p>
This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.   <a href="#bc0369bcd83740cf03cb27a11665486f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#264956cfd878b1c12f28a37e492fc0bb">seek</a> (size_t pos)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Repositions the read point to a specified byte.   <a href="#264956cfd878b1c12f28a37e492fc0bb"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#d075d2536d4fe7075ead6e3a7afd198d">tell</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the current byte offset from beginning.   <a href="#d075d2536d4fe7075ead6e3a7afd198d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#79d9420839d7cac9a28c96cb9153b63c">eof</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns true if the stream has reached the end.   <a href="#79d9420839d7cac9a28c96cb9153b63c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#47ba6c03cb7bf3182b31c63753729be3">close</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Close the stream; this makes further operations invalid.   <a href="#47ba6c03cb7bf3182b31c63753729be3"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#cee80421c052bd3c6452141f067cfa13">setFreeOnClose</a> (bool free)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets whether or not to free the encapsulated memory on close.  <a href="#cee80421c052bd3c6452141f067cfa13"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#7ebd86825f86b7114024d168e9751395">getName</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the name of the stream, if it has one.  <a href="#7ebd86825f86b7114024d168e9751395"></a><br></td></tr>
<tr><td class="memTemplParams" nowrap colspan="2">template&lt;typename T&gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#05072afd475d6875eedd5fc81a73123a">operator&gt;&gt;</a> (T &amp;val)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#86d2ff5dff63ce4b689dd1d486d3243f">getLine</a> (bool trimAfter=true)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a String containing the next line of data, optionally trimmed for whitespace.  <a href="#86d2ff5dff63ce4b689dd1d486d3243f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#022f49c9313deffc5da4383d59d1f32d">getAsString</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a String containing the entire stream.  <a href="#022f49c9313deffc5da4383d59d1f32d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#1d4e9568e53a8071ea9b29a015425aef">size</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.  <a href="#1d4e9568e53a8071ea9b29a015425aef"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#031fc2b8dde9f716e0d3b32b53c9c46c">mData</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pointer to the start of the data area.  <a href="#031fc2b8dde9f716e0d3b32b53c9c46c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#cf8096ff658fc9016c6cce0d28377b8a">mPos</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pointer to the current position in the memory.  <a href="#cf8096ff658fc9016c6cce0d28377b8a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#529afac3f0ee55d00798f3ef7058a94f">mEnd</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pointer to the end of the memory.  <a href="#529afac3f0ee55d00798f3ef7058a94f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MemoryDataStream.html#1099feda84559859d0e73ccf3589d4a4">mFreeOnClose</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Do we delete the memory on close.  <a href="#1099feda84559859d0e73ccf3589d4a4"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#371660702e913ca2799f0478a2154af7">mName</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The name (e.g. resource name) that can be used to identify the source fot his data (optional).  <a href="#371660702e913ca2799f0478a2154af7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1DataStream.html#260d2aa9971abc5b8412cff1a01d6382">mSize</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Size of the data in the stream (may be 0 if size cannot be determined).  <a href="#260d2aa9971abc5b8412cff1a01d6382"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Common subclass of <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading of data.">DataStream</a> for handling data from chunks of memory. 
<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00169">169</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="2196ee12b153b73e168f3ae3ba3a431e"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="2196ee12b153b73e168f3ae3ba3a431e" args="(void *pMem, size_t size, bool freeOnClose=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::MemoryDataStream::MemoryDataStream           </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>pMem</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>freeOnClose</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Wrap an existing memory chunk in a stream. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>pMem</em>&nbsp;</td><td>Pointer to the exising memory </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>size</em>&nbsp;</td><td>The size of the memory chunk in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>freeOnClose</em>&nbsp;</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="629c4366d9ecb8a06286b7380dd53d26"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="629c4366d9ecb8a06286b7380dd53d26" args="(const String &amp;name, void *pMem, size_t size, bool freeOnClose=false)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::MemoryDataStream::MemoryDataStream           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>pMem</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>freeOnClose</em> = <code>false</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Wrap an existing memory chunk in a named stream. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name to give the stream </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>pMem</em>&nbsp;</td><td>Pointer to the exising memory </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>size</em>&nbsp;</td><td>The size of the memory chunk in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>freeOnClose</em>&nbsp;</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="24bf41fe1508cbf5d98280c6208a0e11"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="24bf41fe1508cbf5d98280c6208a0e11" args="(DataStream &amp;sourceStream, bool freeOnClose=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::MemoryDataStream::MemoryDataStream           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sourceStream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>freeOnClose</em> = <code>true</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a stream which pre-buffers the contents of another stream. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>sourceStream</em>&nbsp;</td><td>Another <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading of data.">DataStream</a> which will provide the source of data </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>freeOnClose</em>&nbsp;</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="6895d655ea18c8a2555089413b6fda58"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="6895d655ea18c8a2555089413b6fda58" args="(DataStreamPtr &amp;sourceStream, bool freeOnClose=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::MemoryDataStream::MemoryDataStream           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sourceStream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>freeOnClose</em> = <code>true</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a stream which pre-buffers the contents of another stream. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>sourceStream</em>&nbsp;</td><td>Weak reference to another <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading of data.">DataStream</a> which will provide the source of data </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>freeOnClose</em>&nbsp;</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="8a0f76143497a2ae9ad691ed1555e4db"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="8a0f76143497a2ae9ad691ed1555e4db" args="(const String &amp;name, DataStream &amp;sourceStream, bool freeOnClose=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::MemoryDataStream::MemoryDataStream           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1DataStream.html">DataStream</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sourceStream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>freeOnClose</em> = <code>true</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a named stream which pre-buffers the contents of another stream. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name to give the stream </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>sourceStream</em>&nbsp;</td><td>Another <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading of data.">DataStream</a> which will provide the source of data </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>freeOnClose</em>&nbsp;</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="93c7bb53e6b5a70df93a07b6b8669b2b"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="93c7bb53e6b5a70df93a07b6b8669b2b" args="(const String &amp;name, const DataStreamPtr &amp;sourceStream, bool freeOnClose=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::MemoryDataStream::MemoryDataStream           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sourceStream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>freeOnClose</em> = <code>true</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a named stream which pre-buffers the contents of another stream. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This constructor can be used to intentionally read in the entire contents of another stream, copying them to the internal buffer and thus making them available in memory as a single unit. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name to give the stream </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>sourceStream</em>&nbsp;</td><td>Another <a class="el" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading of data.">DataStream</a> which will provide the source of data </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>freeOnClose</em>&nbsp;</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="d19e7001cc8f2568c15a8beaf938ea14"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="d19e7001cc8f2568c15a8beaf938ea14" args="(size_t size, bool freeOnClose=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::MemoryDataStream::MemoryDataStream           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>freeOnClose</em> = <code>true</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a stream with a brand new empty memory chunk. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>size</em>&nbsp;</td><td>The size of the memory chunk to create in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>freeOnClose</em>&nbsp;</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="beef8ef4c1c13f8b3b91d13e9fd4269e"></a><!-- doxytag: member="Ogre::MemoryDataStream::MemoryDataStream" ref="beef8ef4c1c13f8b3b91d13e9fd4269e" args="(const String &amp;name, size_t size, bool freeOnClose=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::MemoryDataStream::MemoryDataStream           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>freeOnClose</em> = <code>true</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Create a named stream with a brand new empty memory chunk. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>name</em>&nbsp;</td><td>The name to give the stream </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>size</em>&nbsp;</td><td>The size of the memory chunk to create in bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>freeOnClose</em>&nbsp;</td><td>If true, the memory associated will be destroyed when the stream is destroyed. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="fffeeea1e906ef13aac0fdde018d3194"></a><!-- doxytag: member="Ogre::MemoryDataStream::~MemoryDataStream" ref="fffeeea1e906ef13aac0fdde018d3194" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::MemoryDataStream::~MemoryDataStream           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="9d866cd1bbe58bbc59fdbc1dba024b9f"></a><!-- doxytag: member="Ogre::MemoryDataStream::getPtr" ref="9d866cd1bbe58bbc59fdbc1dba024b9f" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* Ogre::MemoryDataStream::getPtr           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get a pointer to the start of the memory block this stream holds. 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00274">274</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c753e2375fcdf5e137210339350b5f21"></a><!-- doxytag: member="Ogre::MemoryDataStream::getCurrentPtr" ref="c753e2375fcdf5e137210339350b5f21" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* Ogre::MemoryDataStream::getCurrentPtr           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get a pointer to the current position in the memory block this stream holds. 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00277">277</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="b3ee46ce477d58f8945340a4e2117820"></a><!-- doxytag: member="Ogre::MemoryDataStream::read" ref="b3ee46ce477d58f8945340a4e2117820" args="(void *buf, size_t count)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::MemoryDataStream::read           </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>count</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Read the requisite number of bytes from the stream, stopping at the end of the file. <p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>buf</em>&nbsp;</td><td>Reference to a buffer pointer </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>count</em>&nbsp;</td><td>Number of bytes to read </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The number of bytes read </dd></dl>
 
<p>

<p>Implements <a class="el" href="classOgre_1_1DataStream.html#ebedb14c79369be5b8750d834b128b9b">Ogre::DataStream</a>.</p>

</div>
</div><p>
<a class="anchor" name="398aa1ba9f58276dc868d2c3968953c4"></a><!-- doxytag: member="Ogre::MemoryDataStream::readLine" ref="398aa1ba9f58276dc868d2c3968953c4" args="(char *buf, size_t maxCount, const String &amp;delim=&quot;\n&quot;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::MemoryDataStream::readLine           </td>
          <td>(</td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>maxCount</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>delim</em> = <code>&quot;\n&quot;</code></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get a single line from the stream. <p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>If you used this function, you <b>must</b> open the stream in <b>binary mode</b>, otherwise, it'll produce unexpected results. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>buf</em>&nbsp;</td><td>Reference to a buffer pointer </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>maxCount</em>&nbsp;</td><td>The maximum length of data to be read, excluding the terminating character </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>delim</em>&nbsp;</td><td>The delimiter to stop at </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The number of bytes read, excluding the terminating character </dd></dl>
 
<p>

<p>Reimplemented from <a class="el" href="classOgre_1_1DataStream.html#edc53a8cff5334563283a4557d423b25">Ogre::DataStream</a>.</p>

</div>
</div><p>
<a class="anchor" name="581ccd32944288808f7602b29a0218e9"></a><!-- doxytag: member="Ogre::MemoryDataStream::skipLine" ref="581ccd32944288808f7602b29a0218e9" args="(const String &amp;delim=&quot;\n&quot;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::MemoryDataStream::skipLine           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>delim</em> = <code>&quot;\n&quot;</code>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Skip a single line from the stream. <p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>If you used this function, you <b>must</b> open the stream in <b>binary mode</b>, otherwise, it'll produce unexpected results. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>delim</em>&nbsp;</td><td>The delimiter(s) to stop at </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The number of bytes skipped </dd></dl>
 
<p>

<p>Reimplemented from <a class="el" href="classOgre_1_1DataStream.html#32966ad5a814f8c72fe0affbefcc6f55">Ogre::DataStream</a>.</p>

</div>
</div><p>
<a class="anchor" name="bc0369bcd83740cf03cb27a11665486f"></a><!-- doxytag: member="Ogre::MemoryDataStream::skip" ref="bc0369bcd83740cf03cb27a11665486f" args="(long count)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::MemoryDataStream::skip           </td>
          <td>(</td>
          <td class="paramtype">long&nbsp;</td>
          <td class="paramname"> <em>count</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Skip a defined number of bytes. <p>
This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.  
<p>

<p>Implements <a class="el" href="classOgre_1_1DataStream.html#776630c409195fdf118a6737571d3d07">Ogre::DataStream</a>.</p>

</div>
</div><p>
<a class="anchor" name="264956cfd878b1c12f28a37e492fc0bb"></a><!-- doxytag: member="Ogre::MemoryDataStream::seek" ref="264956cfd878b1c12f28a37e492fc0bb" args="(size_t pos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::MemoryDataStream::seek           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>pos</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Repositions the read point to a specified byte.  
<p>

<p>Implements <a class="el" href="classOgre_1_1DataStream.html#dc4002e013c279625553ccc3f50ddae1">Ogre::DataStream</a>.</p>

</div>
</div><p>
<a class="anchor" name="d075d2536d4fe7075ead6e3a7afd198d"></a><!-- doxytag: member="Ogre::MemoryDataStream::tell" ref="d075d2536d4fe7075ead6e3a7afd198d" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::MemoryDataStream::tell           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the current byte offset from beginning.  
<p>

<p>Implements <a class="el" href="classOgre_1_1DataStream.html#2d9100f4e9167116fe280a7e7a1b6219">Ogre::DataStream</a>.</p>

</div>
</div><p>
<a class="anchor" name="79d9420839d7cac9a28c96cb9153b63c"></a><!-- doxytag: member="Ogre::MemoryDataStream::eof" ref="79d9420839d7cac9a28c96cb9153b63c" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::MemoryDataStream::eof           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns true if the stream has reached the end.  
<p>

<p>Implements <a class="el" href="classOgre_1_1DataStream.html#81d740638618913333324663b2edb519">Ogre::DataStream</a>.</p>

</div>
</div><p>
<a class="anchor" name="47ba6c03cb7bf3182b31c63753729be3"></a><!-- doxytag: member="Ogre::MemoryDataStream::close" ref="47ba6c03cb7bf3182b31c63753729be3" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::MemoryDataStream::close           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Close the stream; this makes further operations invalid.  
<p>

<p>Implements <a class="el" href="classOgre_1_1DataStream.html#ce95bf415101e195a0c79838fdcb7e7d">Ogre::DataStream</a>.</p>

</div>
</div><p>
<a class="anchor" name="cee80421c052bd3c6452141f067cfa13"></a><!-- doxytag: member="Ogre::MemoryDataStream::setFreeOnClose" ref="cee80421c052bd3c6452141f067cfa13" args="(bool free)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::MemoryDataStream::setFreeOnClose           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>free</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets whether or not to free the encapsulated memory on close. 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00311">311</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7ebd86825f86b7114024d168e9751395"></a><!-- doxytag: member="Ogre::MemoryDataStream::getName" ref="7ebd86825f86b7114024d168e9751395" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; Ogre::DataStream::getName           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the name of the stream, if it has one. 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00072">72</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="05072afd475d6875eedd5fc81a73123a"></a><!-- doxytag: member="Ogre::MemoryDataStream::operator&gt;&gt;" ref="05072afd475d6875eedd5fc81a73123a" args="(T &amp;val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1DataStream.html">DataStream</a>&amp; Ogre::DataStream::operator&gt;&gt;           </td>
          <td>(</td>
          <td class="paramtype">T &amp;&nbsp;</td>
          <td class="paramname"> <em>val</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="86d2ff5dff63ce4b689dd1d486d3243f"></a><!-- doxytag: member="Ogre::MemoryDataStream::getLine" ref="86d2ff5dff63ce4b689dd1d486d3243f" args="(bool trimAfter=true)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Ogre::DataStream::getLine           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>trimAfter</em> = <code>true</code>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a String containing the next line of data, optionally trimmed for whitespace. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This is a convenience method for text streams only, allowing you to retrieve a String object containing the next line of data. The data is read up to the next newline character and the result trimmed if required. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>If you used this function, you <b>must</b> open the stream in <b>binary mode</b>, otherwise, it'll produce unexpected results. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>trimAfter</em>&nbsp;</td><td>If true, the line is trimmed for whitespace (as in String.trim(true,true)) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="022f49c9313deffc5da4383d59d1f32d"></a><!-- doxytag: member="Ogre::MemoryDataStream::getAsString" ref="022f49c9313deffc5da4383d59d1f32d" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> Ogre::DataStream::getAsString           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a String containing the entire stream. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This is a convenience method for text streams only, allowing you to retrieve a String object containing all the data in the stream. </dd></dl>

</div>
</div><p>
<a class="anchor" name="1d4e9568e53a8071ea9b29a015425aef"></a><!-- doxytag: member="Ogre::MemoryDataStream::size" ref="1d4e9568e53a8071ea9b29a015425aef" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t Ogre::DataStream::size           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream. 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00149">149</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="031fc2b8dde9f716e0d3b32b53c9c46c"></a><!-- doxytag: member="Ogre::MemoryDataStream::mData" ref="031fc2b8dde9f716e0d3b32b53c9c46c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* <a class="el" href="classOgre_1_1MemoryDataStream.html#031fc2b8dde9f716e0d3b32b53c9c46c">Ogre::MemoryDataStream::mData</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Pointer to the start of the data area. 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00173">173</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="cf8096ff658fc9016c6cce0d28377b8a"></a><!-- doxytag: member="Ogre::MemoryDataStream::mPos" ref="cf8096ff658fc9016c6cce0d28377b8a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* <a class="el" href="classOgre_1_1MemoryDataStream.html#cf8096ff658fc9016c6cce0d28377b8a">Ogre::MemoryDataStream::mPos</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Pointer to the current position in the memory. 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00175">175</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="529afac3f0ee55d00798f3ef7058a94f"></a><!-- doxytag: member="Ogre::MemoryDataStream::mEnd" ref="529afac3f0ee55d00798f3ef7058a94f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#07f1f7c1d84d58c9beae02e1ebb945e4">uchar</a>* <a class="el" href="classOgre_1_1MemoryDataStream.html#529afac3f0ee55d00798f3ef7058a94f">Ogre::MemoryDataStream::mEnd</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Pointer to the end of the memory. 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00177">177</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1099feda84559859d0e73ccf3589d4a4"></a><!-- doxytag: member="Ogre::MemoryDataStream::mFreeOnClose" ref="1099feda84559859d0e73ccf3589d4a4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1MemoryDataStream.html#1099feda84559859d0e73ccf3589d4a4">Ogre::MemoryDataStream::mFreeOnClose</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Do we delete the memory on close. 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00179">179</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="371660702e913ca2799f0478a2154af7"></a><!-- doxytag: member="Ogre::MemoryDataStream::mName" ref="371660702e913ca2799f0478a2154af7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1DataStream.html#371660702e913ca2799f0478a2154af7">Ogre::DataStream::mName</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
The name (e.g. resource name) that can be used to identify the source fot his data (optional). 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00062">62</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="260d2aa9971abc5b8412cff1a01d6382"></a><!-- doxytag: member="Ogre::MemoryDataStream::mSize" ref="260d2aa9971abc5b8412cff1a01d6382" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1DataStream.html#260d2aa9971abc5b8412cff1a01d6382">Ogre::DataStream::mSize</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Size of the data in the stream (may be 0 if size cannot be determined). 
<p>

<p>Definition at line <a class="el" href="OgreDataStream_8h-source.html#l00064">64</a> of file <a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreDataStream_8h-source.html">OgreDataStream.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:49:30 2008
</p>
</body>
</html>
